Object subclass: #GDir
	instanceVariableNames: 'columna fila'
	classVariableNames: ''
	package: 'Rango2022'!

!GDir methodsFor: 'as yet unclassified' stamp: 'DS 4/24/2022 00:10'!
proximaHorizontal
	^GDir new columna: ((('a' at: 1) asInteger + 1) asCharacter asString) fila: (fila).! !

!GDir methodsFor: 'as yet unclassified' stamp: 'DS 4/9/2022 11:37'!
columna: unaColumna fila: unaFila 
	columna := unaColumna asString .
	fila := unaFila   .! !

!GDir methodsFor: 'as yet unclassified' stamp: 'DS 4/9/2022 11:38'!
proximaVertical
	^Dir new columna: (columna ) fila: (fila + 1).! !


!GDir methodsFor: 'comparing' stamp: 'DS 4/9/2022 11:40'!
mismaColQue: aDir
	^columna = (aDir columna).! !

!GDir methodsFor: 'comparing' stamp: 'DS 4/9/2022 11:40'!
mismaFilaQue: aDir
	^fila = (aDir fila).! !

!GDir methodsFor: 'comparing' stamp: 'DS 4/9/2022 11:41'!
fila 	
	^fila.! !

!GDir methodsFor: 'comparing' stamp: 'DS 4/9/2022 11:40'!
= otraDir
	^(self mismaColQue: otraDir) and: [ self mismaFilaQue: otraDir ]! !


!GDir methodsFor: 'accessing' stamp: 'DS 4/9/2022 11:39'!
columna 
	^columna.! !


Object subclass: #GRango
	instanceVariableNames: 'dirDesde dirHasta'
	classVariableNames: ''
	package: 'Rango2022'!

!GRango methodsFor: 'as yet unclassified' stamp: 'DS 4/24/2022 00:31'!
contieneProximaV: unaDir 
	^((dirDesde proximaVertical ) = unaDir ).! !

!GRango methodsFor: 'as yet unclassified' stamp: 'DS 4/24/2022 00:26'!
contieneHorizontal: unaDir 
" Refactor 1
	
	(dirDesde = unaDir ) ifTrue: [
		^true.
	].

	((dirDesde proximaHorizontal) = unaDir ) ifTrue: [
		^true.
	].
	
	(dirHasta = unaDir ) ifTrue: [
		^true.
	].
	
	^false."
"Refactor 2"
	^(self contieneExtremos: unaDir ) or: [ self contieneProximaH: unaDir  ].! !

!GRango methodsFor: 'as yet unclassified' stamp: 'DS 4/24/2022 00:31'!
contieneVertical: unaDir 
" Refactor 1
	(dirDesde = unaDir ) ifTrue: [
		^true.
	].

	((dirDesde proximaVertical) = unaDir ) ifTrue: [
		^true.
	].
	
	(dirHasta = unaDir ) ifTrue: [
		^true.
	].
	
	^false."
"Refactor 2"
	^(self contieneExtremos: unaDir ) or: [ self contieneProximaV: unaDir  ].! !

!GRango methodsFor: 'as yet unclassified' stamp: 'DS 4/24/2022 00:30'!
contieneExtremos: unaDir 
	^(dirDesde = unaDir ) or: [dirHasta = unaDir].
! !

!GRango methodsFor: 'as yet unclassified' stamp: 'DS 4/24/2022 00:30'!
contieneProximaH: unaDir 
	^((dirDesde proximaHorizontal) = unaDir ).! !


!GRango methodsFor: 'DS' stamp: 'DS 4/24/2022 00:19'!
desde: unaDirDesde hasta: unaDirHasta
	dirDesde := unaDirDesde .
	dirHasta := unaDirHasta .! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GRango class
	instanceVariableNames: 'dirDesde dirHasta'!

!GRango class methodsFor: 'DS' stamp: 'DS 4/24/2022 00:18'!
desde: unaDirDesde hasta: unaDirHasta
	|result|
	result := self new.
	result desde: unaDirDesde hasta: unaDirHasta .
	^result.! !


Object subclass: #GRangoH
	instanceVariableNames: 'dirDesde dirHasta rango'
	classVariableNames: ''
	package: 'Rango2022'!

!GRangoH methodsFor: 'as yet unclassified' stamp: 'DS 4/24/2022 00:28'!
contiene: unaDir 

"	(dirDesde = unaDir ) ifTrue: [
		^true.
	].

	((dirDesde proximaHorizontal) = unaDir ) ifTrue: [
		^true.
	].
	
	(dirHasta = unaDir ) ifTrue: [
		^true.
	].
	
	^false.
"
"Refactor 1"
	^rango contieneHorizontal: unaDir.! !


!GRangoH methodsFor: 'DS' stamp: 'DS 4/24/2022 00:09'!
desde: unaDirDesde hasta: unaDirHasta
"	dirDesde := unaDirDesde .
	dirHasta := unaDirHasta ."
"Refactor 1"
	rango := GRango desde: unaDirDesde hasta: unaDirHasta .
! !


Object subclass: #GRangoV
	instanceVariableNames: 'dirDesde dirHasta rango'
	classVariableNames: ''
	package: 'Rango2022'!

!GRangoV methodsFor: 'DS' stamp: 'DS 4/24/2022 00:22'!
desde: unaDirDesde hasta: unaDirHasta 
	rango := GRango desde: unaDirDesde  hasta: unaDirHasta .! !


!GRangoV methodsFor: 'as yet unclassified' stamp: 'DS 4/24/2022 00:24'!
contiene: unaDir 
"	(dirDesde = unaDir ) ifTrue: [
		^true.
	].

	((dirDesde proximaVertical) = unaDir ) ifTrue: [
		^true.
	].
	
	(dirHasta = unaDir ) ifTrue: [
		^true.
	].
	
	^false.

"
	^rango contieneVertical: unaDir . ! !
TestCase subclass: #TestGDir
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Rango2022-Test'!

!TestGDir methodsFor: 'tests' stamp: 'DS 4/24/2022 00:10'!
testB1EsElSiguienteHorizontalDeA1
	|b1 a1|
	a1 := GDir new columna: $a fila: 1.
	b1 := GDir new columna: $b fila: 1.
	 
	self assert: (a1 proximaHorizontal ) equals: b1.! !


TestCase subclass: #TestRangH
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Rango2022-Test'!

!TestRangH methodsFor: 'tests' stamp: 'DS 4/7/2022 21:26'!
testDesdeA1C1ContieneA1B1C1NoD1
	|rango a1 c1 b1 a4|
	a1 := Dir new columna: $a fila: 1.
	c1 := Dir new columna: $c fila: 1.
	b1 := Dir new columna: $b fila: 1.
	a4 := Dir new columna: $a fila: 4.
	rango := GRangoH new desde: a1 hasta: c1.
	
	self assert: (rango contiene: a1).
	self assert: (rango contiene: b1).
	self assert: (rango contiene: c1).
	self deny: (rango contiene: a4).! !


TestCase subclass: #TestRangV
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Rango2022-Test'!

!TestRangV methodsFor: 'tests' stamp: 'DS 4/24/2022 00:10'!
testDesdeA1A3ContieneA1A2A3NoA4
	|rango a1 a2 a3 a4|
	a1 := GDir new columna: $a fila: 1.
	a2 := GDir new columna: $a fila: 2.
	a3 := GDir new columna: $a fila: 3.
	a4 := GDir new columna: $a fila: 4.
	rango := GRangoV new desde: a1 hasta: a3.
	
	self assert: (rango contiene: a1).
	self assert: (rango contiene: a2).
	self assert: (rango contiene: a3).
	self deny: (rango contiene: a4).! !
